/* @(#) $Id: route.h 1378 2018-11-09 22:04:39Z leres $ (LBL) */
#ifndef acld_route_h
#define acld_route_h

/* ACLD route types */
enum aroutetype {
	ROUTE_UNKNOWN = 0,
	ROUTE_STATIC,
	ROUTE_DYNAMIC,
	ROUTE_INTERFACE,
	ROUTE_NULLZERO
};

/* ACLD route */
struct aroute {
	enum aroutetype type;
	struct addr dst;
	struct addr gw;
	char *raw;			/* text as returned from the router */
};

extern struct s2v str2route[];

extern int goodnullzero(struct addr *);
extern int nullzeronetadd(const char *);
extern void routeadd(struct state *, struct aroute *);
extern int routedelete(struct state *, struct aroute *);
extern struct aroute *routefind(struct state *, struct aroute *);
extern const char *routeformat(struct aroute *);
extern void routefree(struct state *);
extern void routeinit(struct state *);
extern void routelistsfree(struct state *);
extern int routestradd(struct state *, const char *);
#endif
